dim digitval(7)
dim digit$(7)
digitval(1) = 1000
digitval(2) = 500
digitval(3) = 100
digitval(4) = 50
digitval(5) = 10
digitval(6) = 5
digitval(7) = 1
digit$(1) = "M"
digit$(2) = "D"
digit$(3) = "C"
digit$(4) = "L"
digit$(5) = "X"
digit$(6) = "V"
digit$(7) = "I"
input "Give me a whole number: "; arabic
' Convert the number to a positive integer
arabic = int(abs(arabic))
print "In Roman numerals, "; arabic;
' Starting with the largest values, see how many times each one will fit into the number
for n = 1 to 7
    while arabic >= digitval(n)
          roman$ = roman$ + digit$(n)
          arabic = arabic - digitval(n)
    wend
    ' Unless we're down to 1, try the current value minus the next one - e.g. 4 if IV
    if n < 7 then
        ' For 1000, 100 and 10 you skip 2 (which is what the MOD 2 does), e.g. 99 is XCIX rather than IC
        if arabic >= (digitval(n) - digitval(n+1+(n MOD 2))) then
            roman$ = roman$ + digit$(n+1+(n MOD 2)) + digit$(n)
            arabic = arabic - (digitval(n) - digitval(n+1+(n MOD 2)))
        end if
    end if
next
print " is "; roman$

